#include <rtthread.h>
#include <board.h>
#include "nuc97x_can.h"
#include <drivers/can.h>
#include "app_can.h"
#define CAN_ID 0x12

/* can_device */
static rt_device_t can_device = RT_NULL;

/* ڽϢϢ*/
static rt_mq_t rx_mq;

static int count = 0;

void can_set(const rt_uint16_t c)
{
	struct can_configure cfg = {0};
	rt_uint32_t arg = CAN1MBaud;
	rt_device_control(can_device, RT_CAN_CMD_SET_BAUD, &arg);
}
/*
static rt_err_t rx_ind(rt_device_t dev, rt_size_t size)
{
	//* ϢϢ
	rt_mq_send(rx_mq, &size, sizeof(size));

	rt_kprintf("rx_ind size %d.\n", size);

    return RT_EOK;
}
*/

void can_recvmsg(struct rt_can_msg *msg)
{
	rt_size_t size = 0;
	struct rt_can_msg can_msg = {0};
	rt_err_t result = RT_EOK;

	/* ϢжȡϢ*/
	result = rt_mq_recv(rx_mq, &size, sizeof(size), 500);
	if (result == -RT_ETIMEOUT)
	{
	    /* ճʱ*/
	    rt_kprintf("timeout count:%d\n", ++count);
	}

	/* ɹյϢ*/
	if (result == RT_EOK)
	{
		count = 0;

	    rt_uint32_t rx_length;

	    /* ȡϢ*/
	    rx_length = rt_device_read(can_device, 0, &can_msg,
	            sizeof(can_msg));

		if(rx_length > 0)
		{
			rt_memcpy(msg, &can_msg, sizeof(can_msg));
		}
	}
}

rt_size_t can_sendmsg(const rt_uint8_t *data, const rt_uint32_t len)
{
	struct rt_can_msg msg = {0};
	msg.id = CAN_ID;
	msg.ide = RT_CAN_STDID;
	msg.rtr = 0;
	msg.len = len;
	rt_memcpy(msg.data, data, len);

    return rt_device_write(can_device, 0, &msg, sizeof(msg));
}

#define  RCV_DATA (1<<10)
static struct  rt_event can1_event;
rt_err_t rx_ind1(rt_device_t dev, rt_size_t size)
{
	return 	rt_event_send(&can1_event, size);//RCV_DATA
}



static struct  rt_event can2_event;
rt_err_t rx_ind2(rt_device_t dev, rt_size_t size)
{
	return 	rt_event_send(&can2_event, size);
}

rt_err_t can_open(const char *name)
{
    rt_err_t res;

    /* ϵͳеcan豸 */
    can_device = rt_device_find(name);
    /* ҵ豸 */
    if (can_device != RT_NULL)
    {
		res = rt_device_set_rx_indicate(can_device, rx_ind1);
		/* 鷵ֵ */
		if (res != RT_EOK)
		{
			rt_kprintf("set %s rx indicate error.%d\n",name,res);
			return -RT_ERROR;
		}

        /* 豸ԿɶджϷʽ */
        res = rt_device_open(can_device, RT_DEVICE_OFLAG_RDWR | RT_DEVICE_FLAG_INT_RX | RT_DEVICE_FLAG_INT_TX);
        /* 鷵ֵ */
        if (res != RT_EOK)
        {
            rt_kprintf("open %s device error.%d\n",name,res);
            return -RT_ERROR;
        }
    }
    else
    {
        rt_kprintf("can't find %s device.\n",name);
        return -RT_ERROR;
    }

    rx_mq = rt_mq_create("rx_mq", sizeof(rt_size_t), 10, RT_IPC_FLAG_FIFO);

    return RT_EOK;
}
/*
struct filter_config  msg_rx_set0={0,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1,
								  1};

struct filter_config  msg_rx_set1={1,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1};
struct filter_config  msg_rx_set2={2,		//10ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//֡	 DATA_FRAME  (can_priv,REG_IF2_ARB2 ) & ~CAN_IF_ARB2_DIR_Msk));//DIR=0 Էң֡ Խ
								  0x12345,	//ID
								  1};		//end of framme;

struct filter_config  msg_rx_set3={3,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1};

struct filter_config  msg_rx_set4={4,		//10ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//֡	 DATA_FRAME  (can_priv,REG_IF2_ARB2 ) & ~CAN_IF_ARB2_DIR_Msk));//DIR=0 Էң֡ Խ
								  0x12345,	//ID
								  1};		//end of framme;

struct filter_config  msg_rx_set5={5,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1};
struct filter_config  msg_rx_set6={6,		//10ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//֡	 DATA_FRAME  (can_priv,REG_IF2_ARB2 ) & ~CAN_IF_ARB2_DIR_Msk));//DIR=0 Էң֡ Խ
								  0x12345,	//ID
								  1};		//end of framme;

struct filter_config  msg_rx_set7={7,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1};
struct filter_config  msg_rx_set8={8,		//10ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//֡	 DATA_FRAME  (can_priv,REG_IF2_ARB2 ) & ~CAN_IF_ARB2_DIR_Msk));//DIR=0 Էң֡ Խ
								  0x12345,	//ID
								  1};		//end of framme;

struct filter_config  msg_rx_set9={9,		//11ͨ
								  CAN_EXT_ID,//չ֡
		                          0,		//ң֡	REMOTE_FRAME (can_priv,REG_IF2_ARB2 ) | CAN_IF_ARB2_DIR_Msk));//DIR=1Է֡  Խң֡
								  0x12345,	//ID
								  1};
*/
struct rt_can_msg  data_msg ={0x12345, //ID
							 CAN_EXT_ID,//չ֡
							 DATA_FRAME,//֡
							 1, //rtr֡  ֡
							 3,
							 0,
							 0,
							 0,
							 {12,34,56}
							 };

struct rt_can_msg  remote_msg ={0x12345, //ID
							 CAN_EXT_ID,//չ֡
							 REMOTE_FRAME,//rtr֡ ң֡
							 1,
							 3,
							 0,
							 0,
							 0,
							 {12,34,56}
							 };

struct filter_config2 msg_rx_set10={10,		//10ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&data_msg,//ͼ֡
									0xffffffff // MASK  д 0xbfffffff  ֡ң֡Ļ
								 };		//end of framme;

struct filter_config2  msg_rx_set11={11,		//11ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&remote_msg,//ͼԶ֡
									0xffffffff
								  };
struct filter_config2 msg_rx_set12={12,		//10ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&data_msg,
									0xbfffffff // MASK  д 0xbfffffff  ֡ң֡Ļ
								 };		//end of framme;

struct filter_config2  msg_rx_set13={13,		//11ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&remote_msg,
									0xbfffffff
								  };

struct filter_config2 msg_rx_set0={0,		//10ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&data_msg,
									0xffffffff // MASK  д 0xbfffffff  ֡ң֡Ļ
								 };		//end of framme;

struct filter_config2  msg_rx_set1={1,		//11ͨ
									CAN_IF_MCON_UMASK_Msk|CAN_IF_MCON_RXIE_Msk | CAN_IF_MCON_EOB_Msk ,// MCOM set
									&remote_msg,
									0xffffffff
								  };

void rt_can1_thread_entry(void *parameter)
{
    struct rt_can_msg msg,data_msg;
    msg.ide=CAN_EXT_ID;
    msg.hdr =2;
    msg.len=3;
    msg.rtr= DATA_FRAME ;// DATA_FRAME or  REMOTE_FRAME
    msg.id=0x12345;
    msg.data[0]=0x1;
    msg.data[1]=0x23;
    msg.data[2]=0x45;
    rt_device_t candev;
    rt_uint32_t e;
    rt_uint8_t objnum=0;
    candev = rt_device_find("can1");
    RT_ASSERT(candev);
    rt_event_init(&can1_event,"can1", RT_IPC_FLAG_FIFO);
    rt_device_open(candev, (RT_DEVICE_OFLAG_RDWR | RT_DEVICE_FLAG_INT_RX |RT_DEVICE_FLAG_INT_TX));
    rt_device_set_rx_indicate(candev,  rx_ind1);
    rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set10);
    rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set11);
   // rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set0);
   // rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set1);
    while (1)
    {

      	rt_thread_delay(RT_TICK_PER_SECOND *5);

        	rt_device_write(candev, 0, &msg, sizeof(msg));

        	rt_kprintf("************send finish*********\r\n");
        	//   rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set0);
        	//   rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set1);


        	if (
                rt_event_recv(&can1_event,
                				 (1ul<<0)|(1ul<<1)|(1ul << 10)|(1ul<<11),
    							 RT_EVENT_FLAG_OR|RT_EVENT_FLAG_CLEAR	,
    							 RT_WAITING_FOREVER, &e) == RT_EOK
            )
                if (e & (1 << msg_rx_set10.msgobj))

                {
                if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
                    {
						if(data_msg.rtr==DATA_FRAME)
						{
						rt_kprintf("rt_can_thread 1 recev  a  data frame at 10 channel \r\n");
						CAN_ShowMsg(&data_msg);
						}

                    }

                }
				if (e & (1 << msg_rx_set11.msgobj))

				{
				if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
					{
						if(data_msg.rtr==REMOTE_FRAME)
						{
						rt_kprintf("rt_can_thread 1 recev  a remote frame at 11 channel \r\n");
						CAN_ShowMsg(&data_msg);
						}

					}

				}


				if (e & (1 << msg_rx_set0.msgobj))

				                {
				                if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
				                    {
										if(data_msg.rtr==DATA_FRAME)
										{
										rt_kprintf("rt_can_thread 1 recev  a  data frame at 10 channel \r\n");
										CAN_ShowMsg(&data_msg);
										}

				                    }

				                }
								if (e & (1 << msg_rx_set1.msgobj))

								{
								if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
									{
										if(data_msg.rtr==REMOTE_FRAME)
										{
										rt_kprintf("rt_can_thread 1 recev  a remote frame at 11 channel \r\n");
										CAN_ShowMsg(&data_msg);
										}

									}

								}





    }
}

void rt_can2_thread_entry(void *parameter)
{
    struct rt_can_msg msg,data_msg;
    rt_device_t candev;
    rt_uint32_t e;
    msg.ide=CAN_EXT_ID;
    msg.hdr =2;
    msg.len=3;
    msg.rtr= REMOTE_FRAME;// DATA_FRAME or  REMOTE_FRAME
    msg.id=0x12345;
    msg.data[0]=0x1;
    msg.data[1]=0x23;
    msg.data[2]=0x45;
    candev = rt_device_find("can2");
    RT_ASSERT(candev);
    rt_event_init(&can2_event,"can2", RT_IPC_FLAG_FIFO);
    rt_device_open(candev, (RT_DEVICE_OFLAG_RDWR | RT_DEVICE_FLAG_INT_RX |RT_DEVICE_FLAG_INT_TX));
    rt_device_set_rx_indicate(candev,  rx_ind2);
    rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set10);
    rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set11);
  //  rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set0);
  //  rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set1);
    while (1)
    {
       // rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set0);
       // rt_device_control(candev, RT_CAN_CMD_SET_FILTER, &msg_rx_set1);
        if (
            rt_event_recv(&can2_event,
            				(1ul<<0)|(1ul<<1)|( 1<<10)|(1<<11),
							 RT_EVENT_FLAG_OR|RT_EVENT_FLAG_CLEAR	,
							 RT_WAITING_FOREVER, &e) != RT_EOK
        )
        {
            continue;
        }


        if (e & (1 << msg_rx_set10.msgobj))
        {
        if( rt_device_read(candev, 0, &msg, sizeof(msg))==sizeof(msg) )
            {
        	if(msg.rtr==DATA_FRAME)//rtr =0 ʾյ֡
        	{
				rt_kprintf("*********rt_can_thread 2 recev  a data frame  at 10 channel ***********\r\n");
				CAN_ShowMsg(&msg);


				msg.rtr =DATA_FRAME;
				msg.len =3;
				msg.data[0] = 0x12;
				msg.data[1] = 0x34;
				msg.data[2] = 0x56;

				rt_device_write(candev, 0, &msg, sizeof(msg));
				rt_kprintf("*********rt_can_thread 2 send end ***********\r\n");

        	}
            }

        }

        if (e & (1 << msg_rx_set11.msgobj))
        {
        if( rt_device_read(candev, 0, &msg, sizeof(msg))==sizeof(msg) )
            {
        	if(msg.rtr==REMOTE_FRAME) //rtr=1 ʾյԶ֡
        	{
				rt_kprintf("*********rt_can_thread 2 recev  a remote frame  at 11 channel ***********\r\n");
				CAN_ShowMsg(&msg);


				msg.rtr = REMOTE_FRAME;
				msg.len =3;
				msg.data[0] = 0x12;
				msg.data[1] = 0x34;
				msg.data[2] = 0x56;

				rt_device_write(candev, 0, &msg, sizeof(msg));
				rt_kprintf("*********rt_can_thread 2 send a data frame  end ***********\r\n");

        	}
            }

        }



        if (e & (1 << msg_rx_set0.msgobj))

                        {
                        if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
                            {
        						if(data_msg.rtr==REMOTE_FRAME)
        						{
        						rt_kprintf("rt_can_thread 1 recev  a  remote frame at 0 channel \r\n");
        						CAN_ShowMsg(&data_msg);
        						msg.rtr = REMOTE_FRAME;
        						msg.id=0x12345;
        						msg.len =3;
        						msg.data[0] = 0x12;
        						msg.data[1] = 0x34;
        						msg.data[2] = 0x56;

        						rt_device_write(candev, 0, &msg, sizeof(msg));
        						rt_kprintf("*********rt_can_thread 2 send a data frame  end ***********\r\n");
        						}

                            }

                        }
        				if (e & (1 << msg_rx_set1.msgobj))

        				{
        				if( rt_device_read(candev, 0, &data_msg, sizeof(data_msg))==sizeof(data_msg) )
        					{
        						if(data_msg.rtr==REMOTE_FRAME)
        						{
        						rt_kprintf("rt_can_thread 1 recev  a remote frame at 1 channel \r\n");
        						CAN_ShowMsg(&data_msg);
        						msg.rtr = REMOTE_FRAME;
        						msg.id=0x12345;
        						msg.len =3;
        						msg.data[0] = 0x12;
        						msg.data[1] = 0x34;
        						msg.data[2] = 0x56;

        						rt_device_write(candev, 0, &msg, sizeof(msg));
        						rt_kprintf("*********rt_can_thread 2 send a data frame  end ***********\r\n");
        						}

        					}

        				}


    }

}


int rt_can_app_init(void)
{
    rt_thread_t tid;

    tid = rt_thread_create("canapp1",
                           rt_can1_thread_entry, RT_NULL,
                           1024, RT_THREAD_PRIORITY_MAX / 3 - 1, 20);
    if (tid != RT_NULL) rt_thread_startup(tid);


    tid = rt_thread_create("canapp2",
                           rt_can2_thread_entry, RT_NULL,
                           1024, RT_THREAD_PRIORITY_MAX / 3 - 1, 20);
    if (tid != RT_NULL) rt_thread_startup(tid);


    return 0;
}

INIT_APP_EXPORT(rt_can_app_init);

